(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('primeng/button'), require('primeng/progressspinner'), require('@angular/router'), require('@angular/forms'), require('ngx-primeng-grid'), require('ngx-primeng-form'), require('primeng/confirmdialog'), require('rxjs'), require('primeng/api'), require('primeng/dynamicdialog'), require('lodash')) :
    typeof define === 'function' && define.amd ? define('ngx-wrapper', ['exports', '@angular/core', '@angular/common', 'primeng/button', 'primeng/progressspinner', '@angular/router', '@angular/forms', 'ngx-primeng-grid', 'ngx-primeng-form', 'primeng/confirmdialog', 'rxjs', 'primeng/api', 'primeng/dynamicdialog', 'lodash'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-wrapper'] = {}, global.ng.core, global.ng.common, global.button, global.progressspinner, global.ng.router, global.ng.forms, global.ngxPrimengGrid, global.ngxPrimengForm, global.confirmdialog, global.rxjs, global.api, global.dynamicdialog, global._));
}(this, (function (exports, i0, common, button, progressspinner, router, forms, ngxPrimengGrid, ngxPrimengForm, confirmdialog, rxjs, api, dynamicdialog, _) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var ___namespace = /*#__PURE__*/_interopNamespace(_);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || from);
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var NgxInlineLoaderComponent = /** @class */ (function () {
        function NgxInlineLoaderComponent() {
            this.label = 'Loading...';
        }
        NgxInlineLoaderComponent.prototype.ngOnInit = function () {
        };
        return NgxInlineLoaderComponent;
    }());
    NgxInlineLoaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-inline-loader',
                    template: "<div class=\"text-center\">\r\n    <div>\r\n        <p-progressSpinner></p-progressSpinner>\r\n    </div>\r\n    <strong class=\"d-block\">{{label}}</strong>\r\n</div>",
                    styles: [""]
                },] }
    ];
    NgxInlineLoaderComponent.ctorParameters = function () { return []; };
    NgxInlineLoaderComponent.propDecorators = {
        label: [{ type: i0.Input }]
    };

    var NgxSearchComponent = /** @class */ (function () {
        function NgxSearchComponent() {
            // place holder
            this.placeholder = 'Search';
            // initial value
            this.value = null;
            // on search
            this.onSearch = new i0.EventEmitter();
        }
        NgxSearchComponent.prototype.ngOnInit = function () { };
        NgxSearchComponent.prototype.handleSearch = function (value) {
            this.onSearch.emit(value);
        };
        return NgxSearchComponent;
    }());
    NgxSearchComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-search',
                    template: "<div class=\"card-header\">\r\n    <!-- Form -->\r\n    <div class=\"row align-items-center\">\r\n        <div class=\"col\">\r\n            <div class=\"input-group input-group-flush input-group-merge\">\r\n                <!-- Input -->\r\n                <input type=\"search\" class=\"form-control form-control-prepended list-search\" [placeholder]=\"placeholder\"\r\n                    autocomplete=\"off\" (input)=\"handleSearch($event.target.value)\">\r\n                <!-- Prepend -->\r\n                <div class=\"input-group-prepend\">\r\n                    <div class=\"input-group-text\">\r\n                        <span class=\"pi pi-search\"></span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <!--Content-->\r\n        <ng-content></ng-content>\r\n    </div>\r\n\r\n</div>",
                    styles: [""]
                },] }
    ];
    NgxSearchComponent.propDecorators = {
        placeholder: [{ type: i0.Input }],
        value: [{ type: i0.Input }],
        onSearch: [{ type: i0.Output }]
    };

    var NgxHeaderComponent = /** @class */ (function () {
        function NgxHeaderComponent() {
            // breadcrumbs
            this.breadcrumbs = [];
        }
        NgxHeaderComponent.prototype.ngOnInit = function () { };
        return NgxHeaderComponent;
    }());
    NgxHeaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-header',
                    template: "<div class=\"header\">\r\n    <div class=\"header-body\">\r\n        <div class=\"row align-items-center\">\r\n            <div class=\"col\">\r\n                <h6 class=\"header-pretitle\" *ngIf=\"breadcrumbs && breadcrumbs.length>0\">\r\n                    <ng-container *ngFor=\"let item of breadcrumbs\">\r\n                        <ng-container *ngIf=\"item.path\">\r\n                            <a [routerLink]=\"item.path\">{{item.name}}</a> / \r\n                        </ng-container>\r\n                        <ng-container *ngIf=\"!item.path\">{{item.name}}</ng-container>\r\n                    </ng-container>\r\n                </h6>\r\n                <h1 class=\"header-title\">{{header}}</h1>\r\n            </div>\r\n            <div class=\"col-auto\">\r\n                <ng-content select=\"[actionContent]\"></ng-content>\r\n            </div>\r\n        </div>\r\n        <!--Content-->\r\n        <ng-content></ng-content>\r\n    </div>\r\n</div>",
                    styles: [""]
                },] }
    ];
    NgxHeaderComponent.ctorParameters = function () { return []; };
    NgxHeaderComponent.propDecorators = {
        header: [{ type: i0.Input }],
        breadcrumbs: [{ type: i0.Input }]
    };

    var NgxCardLayoutComponent = /** @class */ (function () {
        function NgxCardLayoutComponent() {
        }
        NgxCardLayoutComponent.prototype.ngOnInit = function () {
        };
        return NgxCardLayoutComponent;
    }());
    NgxCardLayoutComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-card-layout',
                    template: "<div class=\"card shadow\">\r\n    <div class=\"card-header\">\r\n        <div class=\"row align-items-center\">\r\n            <div class=\"col\">\r\n                <!-- Title -->\r\n                <h4 class=\"card-header-title\"><i class=\"{{headerIcon}}\"></i>{{header}}</h4>\r\n            </div>\r\n            <div class=\"col-auto\">\r\n                <!--Right Content-->\r\n                <ng-content select=\"[rightContent]\"></ng-content>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <!--content-->\r\n    <ng-content></ng-content>\r\n</div>",
                    styles: [""]
                },] }
    ];
    NgxCardLayoutComponent.ctorParameters = function () { return []; };
    NgxCardLayoutComponent.propDecorators = {
        header: [{ type: i0.Input }],
        headerIcon: [{ type: i0.Input }]
    };

    var NgxFullpageLoaderComponent = /** @class */ (function () {
        function NgxFullpageLoaderComponent() {
            this.label = 'Loading...';
        }
        NgxFullpageLoaderComponent.prototype.ngOnInit = function () {
        };
        return NgxFullpageLoaderComponent;
    }());
    NgxFullpageLoaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-fullpage-loader',
                    template: "<div class=\"full-page-loader\">\n    <div class=\"loader-area\">\n        <ngx-inline-loader [label]=\"label\"></ngx-inline-loader>\n    </div>\n</div>\n",
                    styles: [".full-page-loader{height:90vh}.full-page-loader .loader-area{position:absolute;left:50%;top:50%;transform:translate(-50%,-50%)}"]
                },] }
    ];
    NgxFullpageLoaderComponent.ctorParameters = function () { return []; };
    NgxFullpageLoaderComponent.propDecorators = {
        label: [{ type: i0.Input }]
    };

    exports.ListViewDataType = void 0;
    (function (ListViewDataType) {
        ListViewDataType["text"] = "text";
        ListViewDataType["number"] = "number";
        ListViewDataType["date"] = "date";
        ListViewDataType["dateUtc"] = "date_utc";
        ListViewDataType["dateTicks"] = "date_ticks";
        ListViewDataType["dateUtcTicks"] = "date_utc_ticks";
    })(exports.ListViewDataType || (exports.ListViewDataType = {}));

    var NgxListDataViewComponent = /** @class */ (function () {
        function NgxListDataViewComponent() {
            this.items = [];
            this._fieldType = exports.ListViewDataType;
        }
        NgxListDataViewComponent.prototype.ngOnInit = function () {
        };
        return NgxListDataViewComponent;
    }());
    NgxListDataViewComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-list-data-view',
                    template: "<div class=\"list-group list-group-flush\">\n    <!--Display Basic Info-->\n    <div class=\"list-group-item\" *ngFor=\"let item of items\">\n        <div class=\"row align-items-center\">\n            <div class=\"col\"><small>{{item.label}}</small></div>\n            <div class=\"col-auto\">\n                <ng-container [ngSwitch]=\"item.type\">\n                    <small class=\"text-muted\"\n                        *ngSwitchCase=\"_fieldType.dateUtc\">{{item.value|date:'mediumDate':'UTC'}}</small>\n                    <small class=\"text-muted\" *ngSwitchCase=\"_fieldType.date\">{{item.value|date:'mediumDate'}}</small>\n                    <small class=\"text-muted\" *ngSwitchDefault>{{item.value}}</small>\n                </ng-container>\n            </div>\n        </div>\n    </div>\n</div>",
                    styles: [""]
                },] }
    ];
    NgxListDataViewComponent.ctorParameters = function () { return []; };
    NgxListDataViewComponent.propDecorators = {
        items: [{ type: i0.Input }]
    };

    var components = [
        NgxInlineLoaderComponent,
        NgxSearchComponent,
        NgxHeaderComponent,
        NgxCardLayoutComponent,
        NgxFullpageLoaderComponent,
        NgxListDataViewComponent
    ];
    var NgxWrapperSharedModule = /** @class */ (function () {
        function NgxWrapperSharedModule() {
        }
        return NgxWrapperSharedModule;
    }());
    NgxWrapperSharedModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: __spread(components),
                    imports: [
                        common.CommonModule,
                        button.ButtonModule,
                        progressspinner.ProgressSpinnerModule,
                        router.RouterModule
                    ],
                    exports: __spread(components)
                },] }
    ];

    var BaseComponent = /** @class */ (function () {
        function BaseComponent() {
            // store current user
            this.user = null;
            // define store all subscription
            this.subscription = new rxjs.Subscription();
        }
        BaseComponent.prototype.currentUser = function (key) {
            if (key === void 0) { key = 'userInfo'; }
            if (!this.user) {
                var item = JSON.parse(localStorage.getItem(key));
                if (item != null) {
                    this.user = item;
                }
            }
            return this.user;
        };
        // dispose
        BaseComponent.prototype.dispose = function () {
            this.subscription.unsubscribe();
        };
        return BaseComponent;
    }());

    var NgxManageLayoutComponent = /** @class */ (function (_super) {
        __extends(NgxManageLayoutComponent, _super);
        function NgxManageLayoutComponent(router) {
            var _this = _super.call(this) || this;
            _this.router = router;
            // store layout
            _this._layout = null;
            _this.loading = false;
            // fire when user click on add
            _this.onAction = new i0.EventEmitter();
            // fire when filter chnaged
            _this.onFilter = new i0.EventEmitter();
            // search changed
            _this.onSearch = new i0.EventEmitter();
            // breadcrumbs
            _this.breadcrumbs = [];
            // on row check
            _this.onRowSelected = new i0.EventEmitter();
            return _this;
        }
        Object.defineProperty(NgxManageLayoutComponent.prototype, "layout", {
            set: function (value) {
                if (value) {
                    this._layout = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        NgxManageLayoutComponent.prototype.ngOnInit = function () { };
        NgxManageLayoutComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this.templates) {
                this.templates.forEach(function (item) {
                    switch (item.getType()) {
                        case 'custom':
                            {
                                _this.customColumnTemplate = item.template;
                            }
                            break;
                    }
                });
            }
        };
        // handle when user click on add button
        NgxManageLayoutComponent.prototype.handleAdd = function () {
            // check for dialog
            if (this._layout.setting.addOption.mode === 'modal') {
                // oprn 
                this.onAction.emit({ source: 'create' });
            }
            else if (this._layout.setting.addOption.mode === 'link') {
                // link
                this.router.navigateByUrl(this._layout.setting.addOption.link);
            }
            else if (this._layout.setting.addOption.mode === 'custom') {
                // for custom
                this.onAction.emit({ source: 'custom' });
            }
        };
        // handle action for table
        NgxManageLayoutComponent.prototype.handleAction = function ($instance) {
            this.onAction.emit({ source: 'table', instance: $instance });
        };
        // when table filter changed
        NgxManageLayoutComponent.prototype.handleFilterChanged = function ($filter) {
            this.onFilter.emit($filter);
        };
        // handle search
        NgxManageLayoutComponent.prototype.handleSearch = function (text) {
            this.onSearch.emit(text);
        };
        // handle when row selected by user
        NgxManageLayoutComponent.prototype.handleOnRowSelected = function ($event) {
            this.onRowSelected.emit($event);
        };
        return NgxManageLayoutComponent;
    }(BaseComponent));
    NgxManageLayoutComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-manage-layout',
                    template: "<!-- Header -->\r\n<ngx-header [header]=\"_layout?.setting?.pageTitle\" [breadcrumbs]=\"breadcrumbs\">\r\n    <div actionContent>\r\n        <!--Add action-->\r\n        <ng-container *ngIf=\"_layout?.setting?.addOption?.enable\">\r\n            <button type=\"button\" pButton pRipple class=\"p-button-sm p-button-outlined\" (click)=\"handleAdd()\"\r\n                [label]=\"_layout?.setting?.addOption?.label\"></button>\r\n        </ng-container>\r\n        <!--action content-->\r\n        <ng-content select=\"[headerActionContent]\"></ng-content>\r\n    </div>\r\n    <!--Header Main Content-->\r\n    <ng-content select=\"[headerMainContent]\"></ng-content>\r\n</ngx-header>\r\n\r\n<!-- Content -->\r\n<div>\r\n    <!--For top content-->\r\n    <ng-content></ng-content>\r\n    <!--Main Content-->\r\n    <div class=\"row\">\r\n        <div class=\"col-12\">\r\n            <!-- Header -->\r\n            <div class=\"card shadow\">\r\n                <!--Search-->\r\n                <ng-container *ngIf=\"_layout?.setting?.enableSearch\">\r\n                    <ngx-search (onSearch)=\"handleSearch($event)\">\r\n                        <ng-content select=\"[searchContent]\"></ng-content>\r\n                    </ngx-search>\r\n                </ng-container>\r\n\r\n                <!--Ngx Table-->\r\n                <ngx-primeng-basic-grid [key]=\"_layout?.setting?.pk\" [columns]=\"_layout?.columns\" [result]=\"result\"\r\n                    [filter]=\"filter\" (onFilterChanged)=\"handleFilterChanged($event)\" (action)=\"handleAction($event)\"\r\n                    (rowChecked)=\"handleOnRowSelected($event)\" [loading]=\"loading\">\r\n\r\n                    <!--Custom column-->\r\n                    <ng-template gridTemplate=\"custom\" let-row=\"row\" let-column=\"column\">\r\n                        <ng-container *ngTemplateOutlet=\"customColumnTemplate;context:{row:row,column:column}\">\r\n                        </ng-container>\r\n                    </ng-template>\r\n\r\n                </ngx-primeng-basic-grid>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <!--Footer content-->\r\n    <ng-content select=[footer]></ng-content>\r\n</div>",
                    styles: [""]
                },] }
    ];
    NgxManageLayoutComponent.ctorParameters = function () { return [
        { type: router.Router }
    ]; };
    NgxManageLayoutComponent.propDecorators = {
        templates: [{ type: i0.ContentChildren, args: [ngxPrimengGrid.GridCustomTemplate,] }],
        result: [{ type: i0.Input }],
        filter: [{ type: i0.Input }],
        loading: [{ type: i0.Input }],
        layout: [{ type: i0.Input }],
        onAction: [{ type: i0.Output }],
        onFilter: [{ type: i0.Output }],
        onSearch: [{ type: i0.Output }],
        breadcrumbs: [{ type: i0.Input }],
        onRowSelected: [{ type: i0.Output }]
    };

    var NgxValidationService = /** @class */ (function () {
        function NgxValidationService() {
        }
        // fire form control validation
        NgxValidationService.prototype.fireFormControlValidation = function (control) {
            control.markAsTouched();
            control.markAsDirty();
            control.updateValueAndValidity({ emitEvent: true });
        };
        // fire form group validation
        NgxValidationService.prototype.fireFormGroupValidation = function (formGroup) {
            var _this = this;
            Object.keys(formGroup.controls).forEach(function (key) {
                var e_1, _a;
                if (formGroup.controls[key] instanceof forms.FormArray) {
                    var formsArrayControls = formGroup.controls[key];
                    try {
                        for (var _b = __values(formsArrayControls.controls), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var formGroupControl = _c.value;
                            _this.fireFormGroupValidation(formGroupControl);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
                // fire form control validation
                _this.fireFormControlValidation(formGroup.controls[key]);
            });
        };
        // fire form arra validation
        NgxValidationService.prototype.fireFormArrayValidation = function (formArray) {
            var _this = this;
            formArray.controls.forEach(function (control) {
                _this.fireFormGroupValidation(control);
            });
        };
        return NgxValidationService;
    }());
    NgxValidationService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgxValidationService_Factory() { return new NgxValidationService(); }, token: NgxValidationService, providedIn: "root" });
    NgxValidationService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxValidationService.ctorParameters = function () { return []; };

    var NgxUtility = /** @class */ (function () {
        function NgxUtility() {
        }
        // clone object
        NgxUtility.clone = function (obj) {
            return JSON.parse(JSON.stringify(obj));
        };
        NgxUtility.hasProperty = function (obj, property) {
            return obj && obj.hasOwnProperty(property);
        };
        NgxUtility.hasPropertyValue = function (obj, property) {
            return obj && obj.hasOwnProperty(property) && obj[property];
        };
        NgxUtility.toSelectItems = function (items, valueFeild, labelFeild) {
            var result = [];
            if (items && items.length > 0) {
                items.forEach(function (item) {
                    result.push({
                        label: item[labelFeild],
                        value: item[valueFeild]
                    });
                });
            }
            return result;
        };
        NgxUtility.toSelectItemsFormat = function (items, valueFeild, labelFeilds, startSeprator, endSeperator) {
            if (startSeprator === void 0) { startSeprator = '<'; }
            if (endSeperator === void 0) { endSeperator = '>'; }
            var result = [];
            if (items && items.length > 0) {
                items.forEach(function (item) {
                    result.push({
                        label: "" + labelFeilds[0] + startSeprator + labelFeilds[1] + endSeperator,
                        value: item[valueFeild]
                    });
                });
            }
            return result;
        };
        NgxUtility.scrollToTop = function () {
            window.scrollTo({
                top: 0,
                behavior: 'smooth'
            });
        };
        NgxUtility.scrollTo = function (elementId) {
            var element = document.getElementById(elementId);
            if (element) {
                element.scrollIntoView({
                    behavior: 'smooth'
                });
            }
            ;
        };
        NgxUtility.toFloat = function (value, defValue) {
            if (defValue === void 0) { defValue = 0; }
            var v = parseFloat(value);
            if (isNaN(v)) {
                return defValue;
            }
            return v;
        };
        NgxUtility.toFloatExact = function (value) {
            return NgxUtility.toFloat(value.toFixed(10));
        };
        NgxUtility.toInt = function (value, defValue) {
            if (defValue === void 0) { defValue = 0; }
            var v = parseInt(value, 10);
            if (isNaN(v)) {
                return defValue;
            }
            return v;
        };
        NgxUtility.trim = function (obj) {
            if (obj) {
                Object.keys(obj).map(function (k) { return obj[k] = typeof obj[k] == 'string' ? obj[k].trim() : obj[k]; });
            }
        };
        NgxUtility.getUniqueString = function () {
            return new Date().getTime() + "_" + Math.floor((Math.random() * 9999999) + 1);
        };
        NgxUtility.jsonToDate = function (jsonStr) {
            if (jsonStr) {
                // get dt object
                var dt = new Date(jsonStr);
                //NUll check
                return NgxUtility.isValidDate(dt) ? dt : null;
            }
            return null;
        };
        NgxUtility.isValidDate = function (date) {
            //NUll check
            if (date) {
                return isNaN(date.getTime()) ? false : true;
            }
        };
        NgxUtility.localToUtc = function (date) {
            if (NgxUtility.isValidDate(date)) {
                return new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds()));
            }
            return;
        };
        NgxUtility.utcToLocal = function (date) {
            if (NgxUtility.isValidDate(date)) {
                return new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(), date.getUTCHours(), date.getUTCMinutes(), date.getUTCSeconds());
            }
            return null;
        };
        NgxUtility.toDateFormat = function (dtStr, format, timeZone) {
            if (timeZone === void 0) { timeZone = undefined; }
            // get date
            var dt = NgxUtility.jsonToDate(dtStr);
            if (dt) {
                var datePipe = new common.DatePipe('en-US');
                return datePipe.transform(dt, format, timeZone);
            }
            return null;
        };
        NgxUtility.toAmountFormat = function (amount, currency) {
            if (currency === void 0) { currency = ''; }
            if (amount) {
                var decimalPipe = new common.DecimalPipe('en-US');
                return "" + currency + decimalPipe.transform(amount, '1.2-2');
            }
            return null;
        };
        NgxUtility.focusElement = function (elementId) {
            var ele = document.getElementById(elementId);
            if (ele) {
                ele.focus();
                ele.select();
            }
        };
        NgxUtility.dialogContentStyle = function (maxHeight) {
            if (maxHeight === void 0) { maxHeight = '80vh'; }
            return { "max-height": maxHeight, "overflow-y": "auto", "overflow-x": "hidden" };
        };
        NgxUtility.datePickerToDate = function (value, splitChar) {
            if (splitChar === void 0) { splitChar = '-'; }
            if (value) {
                var values = value.split(splitChar);
                // dd-mm-yy - 0-1-2
                return new Date(NgxUtility.toInt(values[2]), NgxUtility.toInt(values[1]) - 1, NgxUtility.toInt(values[0]));
            }
            return null;
        };
        NgxUtility.monthPickerToDate = function (value, splitChar) {
            if (splitChar === void 0) { splitChar = '-'; }
            if (value) {
                var values = value.split(splitChar);
                // dd-mm-yy - 0-1-2
                return new Date(NgxUtility.toInt(values[2]), NgxUtility.toInt(values[1]) - 1, 1);
            }
            return null;
        };
        NgxUtility.isSuccessResult = function (result) {
            return NgxUtility.toInt(result.status) === 1 ? true : false;
        };
        NgxUtility.patchFormValue = function (value, formGroup) {
            if (value) {
                Object.keys(formGroup.controls).forEach(function (controlName) {
                    if (value.hasOwnProperty(controlName)) {
                        var data = value[controlName];
                        formGroup.controls[controlName].setValue(data);
                    }
                });
            }
        };
        NgxUtility.cleanNullableObject = function (obj) {
            Object.keys(obj).forEach(function (key) {
                if (obj[key] && typeof obj[key] === "object")
                    NgxUtility.cleanNullableObject(obj[key]); // recurse
                else if (obj[key] == null)
                    delete obj[key]; // delete
            });
        };
        NgxUtility.getRouteKey = function (key, activatedRoute) {
            if (activatedRoute.snapshot.paramMap.has(key)) {
                return activatedRoute.snapshot.paramMap.get(key);
            }
            else {
                var value = null;
                var parent = activatedRoute.parent;
                var foundKey = false;
                while (!foundKey) {
                    if (parent) {
                        if (parent.snapshot.paramMap.has(key)) {
                            value = parent.snapshot.paramMap.get(key);
                            foundKey = true;
                        }
                        else {
                            parent = parent.parent;
                        }
                    }
                    else {
                        foundKey = true;
                    }
                }
                return value;
            }
        };
        NgxUtility.getRouteData = function (key, activatedRoute) {
            if (NgxUtility.hasProperty(activatedRoute.snapshot.data, key)) {
                return activatedRoute.snapshot.data[key];
            }
            else {
                var value = null;
                var parent = activatedRoute.parent;
                var foundKey = false;
                while (!foundKey) {
                    if (parent) {
                        if (NgxUtility.hasProperty(parent.snapshot.data, key)) {
                            value = parent.snapshot.data[key];
                            foundKey = true;
                        }
                        else {
                            parent = parent.parent;
                        }
                    }
                    else {
                        foundKey = true;
                    }
                }
                return value;
            }
        };
        return NgxUtility;
    }());

    var NgxManageActionLayoutComponent = /** @class */ (function () {
        function NgxManageActionLayoutComponent(validationService, confirmDialog) {
            this.validationService = validationService;
            this.confirmDialog = confirmDialog;
            // action items
            this.actions = [];
            // confirmations
            this.confirmations = [];
            // on submit
            this.onAction = new i0.EventEmitter();
        }
        NgxManageActionLayoutComponent.prototype.ngOnInit = function () {
            // init dialog key
            this.dialogKey = "action_layout_cd_" + NgxUtility.getUniqueString();
            // check there is no actions
            if (this.actions.length == 0) {
                this.actions.push({ key: 'submit', name: 'Submit', styleClass: 'p-button-sm p-button-outlined mr-2', validate: true });
                this.actions.push({ key: 'cancel', name: 'Cancel', styleClass: 'p-button-sm p-button-outlined p-button-danger', validate: false });
            }
        };
        NgxManageActionLayoutComponent.prototype.handleAction = function (item) {
            var _this = this;
            if (item.validate) {
                if (this.form.valid) {
                    // check confirm action
                    this.checkConfirmation(item, function () {
                        _this.onAction.emit(item);
                    });
                }
                else {
                    this.validationService.fireFormGroupValidation(this.form);
                }
            }
            else {
                // check confirm action
                this.checkConfirmation(item, function () {
                    _this.onAction.emit(item);
                });
            }
        };
        NgxManageActionLayoutComponent.prototype.checkConfirmation = function (action, callback) {
            if (this.confirmations && this.confirmations.length > 0) {
                // get the confirm info
                var confirmInfo = this.confirmations.find(function (m) { return m.key == action.key; });
                if (confirmInfo) {
                    this.confirmDialog.confirm({
                        header: confirmInfo.heading ? confirmInfo.heading : 'Confirmation',
                        message: confirmInfo.message,
                        key: this.dialogKey,
                        icon: 'pi pi-exclamation-triangle',
                        accept: function () {
                            callback();
                        }
                    });
                }
                else {
                    callback();
                }
            }
            else {
                callback();
            }
        };
        return NgxManageActionLayoutComponent;
    }());
    NgxManageActionLayoutComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-manage-action-layout',
                    template: "<form [formGroup]=\"form\" autocomplete=\"off\">\r\n    <!--Content-->\r\n    <div>\r\n        <ng-content></ng-content>\r\n    </div>\r\n    <!--Action-->\r\n    <div class=\"d-flex justify-content-end\">\r\n        <hr class=\"m-2\" />\r\n        <button *ngFor=\"let item of actions\" type=\"button\" pButton pRipple class=\"{{item.styleClass}}\"\r\n            (click)=\"handleAction(item)\" [label]=\"item.name\"></button>\r\n    </div>\r\n</form>\r\n<!--Confirm dialog-->\r\n<p-confirmDialog appendTo=\"body\" [key]=\"dialogKey\"></p-confirmDialog>",
                    styles: [""]
                },] }
    ];
    NgxManageActionLayoutComponent.ctorParameters = function () { return [
        { type: NgxValidationService },
        { type: api.ConfirmationService }
    ]; };
    NgxManageActionLayoutComponent.propDecorators = {
        actions: [{ type: i0.Input }],
        confirmations: [{ type: i0.Input }],
        form: [{ type: i0.Input }],
        onAction: [{ type: i0.Output }]
    };

    var NgxManageLayoutModule = /** @class */ (function () {
        function NgxManageLayoutModule() {
        }
        return NgxManageLayoutModule;
    }());
    NgxManageLayoutModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxManageLayoutComponent, NgxManageActionLayoutComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        confirmdialog.ConfirmDialogModule,
                        forms.ReactiveFormsModule,
                        ngxPrimengForm.NgxPrimengFormModule,
                        ngxPrimengGrid.NgxPrimengGridModule,
                        NgxWrapperSharedModule,
                        button.ButtonModule,
                        router.RouterModule
                    ],
                    exports: [NgxManageLayoutComponent, NgxManageActionLayoutComponent]
                },] }
    ];

    var modules = [
        NgxWrapperSharedModule,
        NgxManageLayoutModule
    ];
    var NgxWrapperModule = /** @class */ (function () {
        function NgxWrapperModule() {
        }
        return NgxWrapperModule;
    }());
    NgxWrapperModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    imports: __spread([
                        common.CommonModule
                    ], modules),
                    exports: __spread(modules)
                },] }
    ];

    var DialogBaseComponent = /** @class */ (function (_super) {
        __extends(DialogBaseComponent, _super);
        function DialogBaseComponent(dialogFormInjector) {
            var _this = _super.call(this) || this;
            // prepare instance
            _this.dialogBaseRef = dialogFormInjector.get(dynamicdialog.DynamicDialogRef);
            _this.dialogBaseConfig = dialogFormInjector.get(dynamicdialog.DynamicDialogConfig);
            return _this;
        }
        Object.defineProperty(DialogBaseComponent.prototype, "dialogData", {
            // get dialog data
            get: function () {
                var data = this.dialogBaseConfig.data;
                return data ? data : null;
            },
            enumerable: false,
            configurable: true
        });
        // close dialog
        DialogBaseComponent.prototype.close = function (result) {
            if (result === void 0) { result = null; }
            this.dialogBaseRef.close(result);
        };
        return DialogBaseComponent;
    }(BaseComponent));

    var NgxLambdaUtility = /** @class */ (function () {
        function NgxLambdaUtility() {
        }
        // get member name from expression
        // !!Experimental
        NgxLambdaUtility.getMemberNameFromExpression = function (callbackfn) {
            var methodBody = callbackfn.substring(callbackfn.indexOf('{') + 1, callbackfn.lastIndexOf('}'));
            // get only last part
            var splitItems = methodBody.split('.');
            // check length of split item
            if (splitItems.length === 2) {
                // last item and remove ;, which is added by method
                return splitItems[1].replace(';', '').trim();
            }
            else if (splitItems.length === 3) {
                // last item and remove ;, which is added by method
                return splitItems[2].replace(';', '').trim();
            }
            return null;
        };
        // to select items
        NgxLambdaUtility.toSelectItems = function (items, callbackfnValue, callbackfnLabel) {
            var valueField = this.getMemberNameFromExpression(callbackfnValue.toString());
            var labelField = this.getMemberNameFromExpression(callbackfnLabel.toString());
            return NgxUtility.toSelectItems(items, valueField, labelField);
        };
        return NgxLambdaUtility;
    }());

    var FormBaseComponent = /** @class */ (function (_super) {
        __extends(FormBaseComponent, _super);
        function FormBaseComponent(formInjector) {
            var _this = _super.call(this) || this;
            _this.formBaseValidationService = formInjector.get(NgxValidationService);
            return _this;
        }
        FormBaseComponent.prototype.getValue = function (controlName, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            return formGroup.controls[controlName].value;
        };
        FormBaseComponent.prototype.setValue = function (controlName, data, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            return formGroup.controls[controlName].setValue(data);
        };
        FormBaseComponent.prototype.patchValue = function (value, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            NgxUtility.patchFormValue(value, formGroup);
        };
        FormBaseComponent.prototype.getControl = function (controlName, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            return formGroup.controls[controlName];
        };
        // get the form value from expression
        // !! Expermiental
        FormBaseComponent.prototype.getFormValue = function (callbackfn, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            var memberName = NgxLambdaUtility.getMemberNameFromExpression(callbackfn.toString());
            return this.getValue(memberName, formGroup);
        };
        // set the form value from expression
        // !! Expermiental
        FormBaseComponent.prototype.setFormValue = function (callbackfn, data, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            var memberName = NgxLambdaUtility.getMemberNameFromExpression(callbackfn.toString());
            this.setValue(memberName, data, formGroup);
        };
        // get control by expression
        // !! Expermiental
        FormBaseComponent.prototype.getFormControl = function (callbackfn, formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            var memberName = NgxLambdaUtility.getMemberNameFromExpression(callbackfn.toString());
            return this.getControl(memberName, formGroup);
        };
        FormBaseComponent.prototype.cloneFormGroup = function (copyForm, copyTo, clearAll) {
            if (clearAll === void 0) { clearAll = true; }
            if (clearAll) {
                Object.keys(copyTo.controls).forEach(function (controlName) {
                    copyTo.removeControl(controlName);
                });
            }
            // copy value
            Object.keys(copyForm.controls).forEach(function (controlName) {
                copyTo.addControl(controlName, copyForm.controls[controlName]);
            });
        };
        // fire control validation
        FormBaseComponent.prototype.fireFormControlValidation = function (control) {
            this.formBaseValidationService.fireFormControlValidation(control);
        };
        // fire form group validation
        FormBaseComponent.prototype.fireFormGroupValidation = function (formGroup) {
            if (formGroup === void 0) { formGroup = this.form; }
            this.formBaseValidationService.fireFormGroupValidation(formGroup);
        };
        // fire form arra validation
        FormBaseComponent.prototype.fireFormArrayValidation = function (formArray) {
            this.formBaseValidationService.fireFormArrayValidation(formArray);
        };
        return FormBaseComponent;
    }(BaseComponent));

    var DynamicFormBaseComponent = /** @class */ (function (_super) {
        __extends(DynamicFormBaseComponent, _super);
        function DynamicFormBaseComponent(dynamicFormInjector) {
            var _this = _super.call(this, dynamicFormInjector) || this;
            // prepare instance
            _this.ngxPrimengFormService = dynamicFormInjector.get(ngxPrimengForm.NgxPrimengFormService);
            return _this;
        }
        // prepare form
        DynamicFormBaseComponent.prototype.prepareForm = function (formBuilder, jsonForms) {
            return this.ngxPrimengFormService.prepareForm(formBuilder, jsonForms);
        };
        // load dynamic forms
        DynamicFormBaseComponent.prototype.loadRemoteJsonForm = function (formBuilder, formObservable) {
            var _this = this;
            var observable = new rxjs.Observable(function (observer) {
                var ref = formObservable.subscribe(function (forms) {
                    // load form data
                    var result = _this.prepareForm(formBuilder, forms);
                    // emit event
                    observer.next(result);
                    // complete
                    observer.complete();
                }, function (error) {
                    observer.error(error);
                });
                _this.subscription.add(ref);
            });
            return observable;
        };
        return DynamicFormBaseComponent;
    }(FormBaseComponent));

    var DialogFormBaseComponent = /** @class */ (function (_super) {
        __extends(DialogFormBaseComponent, _super);
        function DialogFormBaseComponent(dialogFormInjector) {
            var _this = _super.call(this, dialogFormInjector) || this;
            // prepare instance
            _this.dialogBaseRef = dialogFormInjector.get(dynamicdialog.DynamicDialogRef);
            _this.dialogBaseConfig = dialogFormInjector.get(dynamicdialog.DynamicDialogConfig);
            return _this;
        }
        Object.defineProperty(DialogFormBaseComponent.prototype, "dialogData", {
            // get dialog data
            get: function () {
                var data = this.dialogBaseConfig.data;
                return data ? data : null;
            },
            enumerable: false,
            configurable: true
        });
        // close dialog
        DialogFormBaseComponent.prototype.closeDialog = function (result) {
            if (result === void 0) { result = null; }
            this.dialogBaseRef.close(result);
        };
        return DialogFormBaseComponent;
    }(DynamicFormBaseComponent));

    var NgxManageLayoutService = /** @class */ (function () {
        function NgxManageLayoutService() {
        }
        NgxManageLayoutService.prototype.process = function (manageJson) {
            if (manageJson) {
                var obj = manageJson;
                var result = {
                    api: obj.api,
                    columns: this.processColumn(obj.columns),
                    setting: this.processSetting(obj.setting),
                    form: this.processForm(obj.form)
                };
                return result;
            }
            return null;
        };
        NgxManageLayoutService.prototype.processColumn = function (columns) {
            if (columns && columns.length > 0) {
            }
            return columns;
        };
        NgxManageLayoutService.prototype.processSetting = function (setting) {
            return {
                pageTitle: setting.pageTitle,
                addOption: this.getAddOption(setting.addOption),
                enableSearch: NgxUtility.hasProperty(setting, 'enableSearch') ? setting.enableSearch : true,
                perPage: NgxUtility.hasProperty(setting, 'perPage') ? setting.perPage : 10,
                pk: setting.pk,
                layoutId: NgxUtility.hasProperty(setting, 'layoutId') ? setting.layoutId : null,
                saveSearch: NgxUtility.hasProperty(setting, 'saveSearch') ? setting.saveSearch : true,
                actionMode: NgxUtility.hasProperty(setting, 'actionMode') ? setting.actionMode : 'block',
                defaultSortColumn: NgxUtility.hasProperty(setting, 'defaultSortColumn') ? setting.defaultSortColumn : null,
                defaultSortOrder: NgxUtility.hasProperty(setting, 'defaultSortOrder') ? setting.defaultSortOrder : -1,
            };
        };
        NgxManageLayoutService.prototype.getAddOption = function (option) {
            if (option) {
                return {
                    enable: NgxUtility.hasProperty(option, 'enable') ? option.enable : false,
                    label: NgxUtility.hasProperty(option, 'label') ? option.label : null,
                    mode: NgxUtility.hasProperty(option, 'mode') ? option.mode : null,
                    link: NgxUtility.hasProperty(option, 'link') ? option.link : null,
                    modalTitle: NgxUtility.hasProperty(option, 'modalTitle') ? option.modalTitle : null,
                    modalWidth: NgxUtility.hasProperty(option, 'modalWidth') ? option.modalWidth : 'auto',
                };
            }
            return null;
        };
        NgxManageLayoutService.prototype.processForm = function (form) {
            return {
                actions: NgxUtility.hasProperty(form, 'actions') ? form.actions : [],
                controls: NgxUtility.hasProperty(form, 'controls') ? form.controls : [],
                confirmations: NgxUtility.hasProperty(form, 'confirmations') ? form.confirmations : [],
            };
        };
        return NgxManageLayoutService;
    }());
    NgxManageLayoutService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgxManageLayoutService_Factory() { return new NgxManageLayoutService(); }, token: NgxManageLayoutService, providedIn: "root" });
    NgxManageLayoutService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxManageLayoutService.ctorParameters = function () { return []; };

    var NgxManageLayoutBaseComponent = /** @class */ (function (_super) {
        __extends(NgxManageLayoutBaseComponent, _super);
        // get manage component
        function NgxManageLayoutBaseComponent(manageInjector) {
            var _this = _super.call(this, manageInjector) || this;
            _this.loading = false;
            // columns
            _this.columns = [];
            // result
            _this.result = { results: [], total: 0 };
            // breadcrumbs
            _this.breadcrumbs = [];
            // selected rows
            _this.selectedRows = [];
            // init instance
            _this.manageDialog = manageInjector.get(dynamicdialog.DialogService);
            _this.ngxLayoutBaseService = manageInjector.get(NgxManageLayoutService);
            _this.activatedBaseRoute = manageInjector.get(router.ActivatedRoute);
            return _this;
        }
        // prepare layout from router
        NgxManageLayoutBaseComponent.prototype.prepareLayoutFromRouter = function (invokeSearch, dataKey) {
            if (invokeSearch === void 0) { invokeSearch = true; }
            if (dataKey === void 0) { dataKey = 'layout'; }
            var data = this.activatedBaseRoute.snapshot.data;
            if (NgxUtility.hasPropertyValue(data, dataKey)) {
                var manageJson = data[dataKey];
                // prepare layout
                this.prepareLayout(manageJson, invokeSearch);
            }
        };
        // prepare layout from service
        NgxManageLayoutBaseComponent.prototype.prepareLayoutFromService = function (jsonObjectService, successCallback, invokeSearch) {
            var _this = this;
            if (invokeSearch === void 0) { invokeSearch = true; }
            var ref = jsonObjectService.subscribe(function (jsonObject) {
                // on success result
                successCallback(jsonObject);
                // prepare layout
                _this.prepareLayout(jsonObject, invokeSearch);
            });
            this.subscription.add(ref);
        };
        // prepare layout from json
        NgxManageLayoutBaseComponent.prototype.prepareLayout = function (jsonObject, invokeSearch) {
            if (!jsonObject) {
                return;
            }
            // get the title
            this.layout = this.ngxLayoutBaseService.process(jsonObject);
            // prepare columns
            this.columns = this.layout.columns;
            //override layout
            this.overrideLayout(this.layout);
            // init filter
            this.initFilter(this.layout.setting);
            // override Filter
            this.overrideFilter(this.filter);
            // do search
            if (invokeSearch) {
                this.doSearch();
            }
        };
        // handle action
        NgxManageLayoutBaseComponent.prototype.handleOnAction = function ($action) {
            if ($action.source === 'create') {
                this.openManageDialog(null);
            }
            else if ($action.source === 'table') {
                this.handleTableAction($action.instance);
            }
            else if ($action.source === 'custom') {
                this.overrideAction(this.layout.setting.addOption);
            }
        };
        // handle when filter changed
        NgxManageLayoutBaseComponent.prototype.handleOnFilter = function ($filter) {
            var reqFilter = ___namespace.cloneDeep($filter);
            // only set basic filter from grid
            this.filter.pageNo = reqFilter.pageNo;
            this.filter.perPage = reqFilter.perPage;
            this.filter.sortField = reqFilter.sortField;
            this.filter.sortOrder = reqFilter.sortOrder;
            this.doSearch();
        };
        // init filter
        NgxManageLayoutBaseComponent.prototype.initFilter = function (setting) {
            this.filter = {
                pageNo: 0,
                perPage: setting.perPage,
                sortField: setting.defaultSortColumn,
                sortOrder: setting.defaultSortOrder,
                formFilter: null,
                searchText: null
            };
        };
        // handle when search changed
        NgxManageLayoutBaseComponent.prototype.handleOnSearch = function (text) {
            // on search reset the page no
            this.filter.pageNo = 0;
            this.filter.searchText = text;
            this.doSearch();
        };
        // handle row selected
        NgxManageLayoutBaseComponent.prototype.handleOnRowSelected = function ($event) {
            this.selectedRows = $event;
        };
        NgxManageLayoutBaseComponent.prototype.handleTableAction = function (instance) {
            switch (instance.column.key) {
                case 'edit':
                    {
                        this.openManageDialog(instance.row);
                    }
                    break;
                case 'delete':
                    {
                        this.handleDelete(instance.row);
                    }
                    break;
                case 'status':
                    {
                        this.handleStatusChange(instance.row);
                    }
                    break;
                default:
                    {
                        this.handleRowAction(instance);
                    }
                    break;
            }
        };
        NgxManageLayoutBaseComponent.prototype.openManageDialog = function (model) {
            var _this = this;
            // data model
            var dataModel = {
                model: model,
                layout: this.layout,
                data: this.getExtraDialogData()
            };
            // dialog
            var dialogRef = this.manageDialog.open(this.getManageDialogComponent(), {
                header: this.layout.setting.addOption.modalTitle,
                width: this.layout.setting.addOption.modalWidth,
                contentStyle: NgxUtility.dialogContentStyle(),
                data: dataModel
            });
            // handle close event
            var ref = dialogRef.onClose.subscribe(function (result) {
                // unsubscribe
                ref.unsubscribe();
                // do work
                if (result) {
                    _this.doSearch();
                }
            });
        };
        NgxManageLayoutBaseComponent.prototype.handleDelete = function (model) {
            var _this = this;
            // pre action
            this.overrideHttpCallPreAction(model);
            var ref = this.getDeleteService(model).subscribe(function (res) {
                // post action
                _this.overrideHttpCallPostAction(res);
                // search
                _this.doSearch();
            });
            this.subscription.add(ref);
        };
        NgxManageLayoutBaseComponent.prototype.handleStatusChange = function (model) {
            var _this = this;
            // pre action
            this.overrideHttpCallPreAction(model);
            var ref = this.getChangeStatusService(model).subscribe(function (res) {
                // post action
                _this.overrideHttpCallPostAction(res);
            });
            this.subscription.add(ref);
        };
        // do search
        NgxManageLayoutBaseComponent.prototype.doSearch = function () {
            var _this = this;
            this.loading = true;
            var ref = this.getSearchService(this.filter).subscribe(function (res) {
                _this.result = res;
                // reset the selected rows
                _this.selectedRows = [];
                // set loading false
                _this.loading = false;
            });
            this.subscription.add(ref);
        };
        //  override Layout
        NgxManageLayoutBaseComponent.prototype.overrideLayout = function ($layout) { };
        // override Filter
        NgxManageLayoutBaseComponent.prototype.overrideFilter = function ($filter) { };
        // override Action for custom
        NgxManageLayoutBaseComponent.prototype.overrideAction = function ($option) { };
        // override http call pre action
        NgxManageLayoutBaseComponent.prototype.overrideHttpCallPreAction = function (model) { };
        // override http call pre action
        NgxManageLayoutBaseComponent.prototype.overrideHttpCallPostAction = function (result) { };
        return NgxManageLayoutBaseComponent;
    }(FormBaseComponent));

    var NgxManageLayoutDialogBaseComponent = /** @class */ (function (_super) {
        __extends(NgxManageLayoutDialogBaseComponent, _super);
        function NgxManageLayoutDialogBaseComponent(manageDialognjector) {
            var _this = _super.call(this, manageDialognjector) || this;
            // define form items
            _this.formItems = [];
            return _this;
        }
        // load form
        NgxManageLayoutDialogBaseComponent.prototype.loadForm = function (formBuilder) {
            // make sure form shoule initialize
            var formResult = this.prepareForm(formBuilder, this.dialogData.layout.form.controls);
            // clone form
            this.cloneFormGroup(formResult.formGroup, this.form);
            // set form items
            this.formItems = formResult.forms;
            // process form data
            this.processData(this.form);
        };
        // process data
        NgxManageLayoutDialogBaseComponent.prototype.processData = function (formGroup) {
            var data = this.dialogData;
            if (data && data.model) {
                //pre action
                // clone
                var model = ___namespace.cloneDeep(data.model);
                // patach value
                this.patchValue(this.overrideSetFormDataPreAction(model), formGroup);
                // post action
                this.overrideSetFormDataPostAction();
            }
        };
        // handle when action performed
        NgxManageLayoutDialogBaseComponent.prototype.handleAction = function (event) {
            switch (event.key) {
                case 'cancel':
                    {
                        this.closeDialog();
                    }
                    break;
                default:
                    {
                        this.handleOnAction(this.getActionFormValue(), event);
                    }
                    break;
            }
        };
        // get action form value
        NgxManageLayoutDialogBaseComponent.prototype.getActionFormValue = function () {
            // get form value
            var formValue = ___namespace.cloneDeep(this.form.value);
            // get dialog data
            var data = ___namespace.cloneDeep(this.dialogData);
            // null check
            if (data && data.model) {
                // set primary key
                // cross check that model has key or not
                if (NgxUtility.hasPropertyValue(data.model, this.dialogData.layout.setting.pk)) {
                    formValue[this.dialogData.layout.setting.pk] = this.dialogData.model[this.dialogData.layout.setting.pk];
                }
            }
            return formValue;
        };
        NgxManageLayoutDialogBaseComponent.prototype.overrideSetFormDataPreAction = function (model) { return model; };
        NgxManageLayoutDialogBaseComponent.prototype.overrideSetFormDataPostAction = function () { };
        return NgxManageLayoutDialogBaseComponent;
    }(DialogFormBaseComponent));

    ;

    var NgxCrudManageComponent = /** @class */ (function (_super) {
        __extends(NgxCrudManageComponent, _super);
        function NgxCrudManageComponent(injector, formBuilder) {
            var _this = _super.call(this, injector) || this;
            _this.formBuilder = formBuilder;
            // define form items
            _this._formItems = [];
            // action 
            _this.onAction = new i0.EventEmitter();
            // init form
            _this.form = _this.formBuilder.group({});
            return _this;
        }
        NgxCrudManageComponent.prototype.ngOnInit = function () {
            // load form
            this.loadForm();
        };
        // load form
        NgxCrudManageComponent.prototype.loadForm = function () {
            if (this.layout) {
                // make sure form shoule initialize
                this.layout.form['controlResult'] = this.prepareForm(this.formBuilder, this.layout.form.controls);
                // clone form
                this.cloneFormGroup(this.layout.form.controlResult.formGroup, this.form);
                // set form items
                this._formItems = this.layout.form.controlResult.forms;
                // process patch value
                if (this.data) {
                    this.layout.form.action.onPatchValue(this.form, this._formItems, this.data);
                }
                // process prepare value
                this.layout.form.action.onPrepareValue(this.form, this._formItems, this.data);
            }
        };
        NgxCrudManageComponent.prototype.handleOnAction = function (action) {
            var _this = this;
            // service call
            if (action.serviceCall) {
                // get form value
                var formValue = ___namespace.cloneDeep(this.form.getRawValue());
                // execute command
                this.layout.form.action.onExecute(formValue, action, this.data, function (result) {
                    if (NgxUtility.isSuccessResult(result)) {
                        // call back
                        _this.onAction.emit({ action: action, result: result });
                    }
                });
            }
            else {
                this.onAction.emit({ action: action });
            }
        };
        NgxCrudManageComponent.prototype.ngOnDestroy = function () {
            this.dispose();
        };
        return NgxCrudManageComponent;
    }(DynamicFormBaseComponent));
    NgxCrudManageComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-crud-manage',
                    template: "<ngx-crud-manage-layout [form]=\"form\" (onAction)=\"handleOnAction($event)\" [actions]=\"layout?.form?.actions\">\n    <ngx-primeng-form [form]=\"form\" [items]=\"_formItems\"></ngx-primeng-form>\n</ngx-crud-manage-layout>",
                    styles: [""]
                },] }
    ];
    NgxCrudManageComponent.ctorParameters = function () { return [
        { type: i0.Injector },
        { type: forms.FormBuilder }
    ]; };
    NgxCrudManageComponent.propDecorators = {
        layout: [{ type: i0.Input }],
        onAction: [{ type: i0.Output }],
        data: [{ type: i0.Input }]
    };

    var NgxCrudManageDialogComponent = /** @class */ (function (_super) {
        __extends(NgxCrudManageDialogComponent, _super);
        function NgxCrudManageDialogComponent(injector) {
            return _super.call(this, injector) || this;
        }
        NgxCrudManageDialogComponent.prototype.ngOnInit = function () {
            var _this = this;
            // layout
            this._layout = this.dialogData.layout;
            // modal
            this._data = this.dialogData.model;
            // patch value
            this._layout.form.action.onPatchValue = function (formGroup, formItems, data) {
                // patch value
                _this.patchValue(data, formGroup);
            };
        };
        NgxCrudManageDialogComponent.prototype.handleOnAction = function (callback) {
            this.closeDialog(callback.action.serviceCall ? callback.result : null);
        };
        NgxCrudManageDialogComponent.prototype.ngOnDestroy = function () {
            this.dispose();
        };
        return NgxCrudManageDialogComponent;
    }(DialogFormBaseComponent));
    NgxCrudManageDialogComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-crud-manage-dialog',
                    template: "<ngx-crud-manage [layout]=\"_layout\" (onAction)=\"handleOnAction($event)\" [data]=\"_data\"></ngx-crud-manage>",
                    styles: [""]
                },] }
    ];
    NgxCrudManageDialogComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };

    var NgxCrudManageLayoutComponent = /** @class */ (function (_super) {
        __extends(NgxCrudManageLayoutComponent, _super);
        function NgxCrudManageLayoutComponent(injector, confirmDialog) {
            var _this = _super.call(this, injector) || this;
            _this.confirmDialog = confirmDialog;
            // actions
            _this.actions = [];
            // on action perfomed
            _this.onAction = new i0.EventEmitter();
            return _this;
        }
        NgxCrudManageLayoutComponent.prototype.ngOnInit = function () {
            // init dialog key
            this._dialogKey = "crud_action_layout_cd_" + new Date().getTime();
            // prepare default actions
            this.prepareDefaultActions();
        };
        NgxCrudManageLayoutComponent.prototype.prepareDefaultActions = function () {
            if (!this.actions) {
                this.actions = [];
                this.actions.push({ key: 'cancel', name: 'Cancel', styleClass: 'p-button-sm p-button-outlined p-button-danger mr-2', validate: false, serviceCall: false });
                this.actions.push({ key: 'submit', name: 'Submit', styleClass: 'p-button-sm p-button-outlined', validate: true, serviceCall: true });
            }
        };
        NgxCrudManageLayoutComponent.prototype.handleAction = function (item) {
            var _this = this;
            if (item.validate) {
                if (this.form.valid) {
                    // check confirm action
                    this.checkConfirmation(item, function () {
                        _this.onAction.emit(item);
                    });
                }
                else {
                    this.fireFormGroupValidation(this.form);
                }
            }
            else {
                // check confirm action
                this.checkConfirmation(item, function () {
                    _this.onAction.emit(item);
                });
            }
        };
        NgxCrudManageLayoutComponent.prototype.checkConfirmation = function (action, callback) {
            if (action.confirmMessage) {
                this.confirmDialog.confirm({
                    header: 'Confirmation',
                    message: action.confirmMessage,
                    key: this._dialogKey,
                    icon: 'pi pi-exclamation-triangle',
                    accept: function () {
                        callback();
                    }
                });
            }
            else {
                callback();
            }
        };
        return NgxCrudManageLayoutComponent;
    }(FormBaseComponent));
    NgxCrudManageLayoutComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-crud-manage-layout',
                    template: "<form [formGroup]=\"form\" autocomplete=\"off\">\n    <!--Content-->\n    <div>\n        <ng-content></ng-content>\n    </div>\n    <!--Action-->\n    <hr class=\"m-3\" />\n    <div class=\"d-flex justify-content-end\">\n        <button *ngFor=\"let item of actions\" type=\"button\" pButton pRipple class=\"{{item.styleClass}}\"\n            (click)=\"handleAction(item)\" [label]=\"item.name\"></button>\n    </div>\n</form>\n<!--Confirm dialog-->\n<p-confirmDialog appendTo=\"body\" [key]=\"_dialogKey\"></p-confirmDialog>",
                    styles: [""]
                },] }
    ];
    NgxCrudManageLayoutComponent.ctorParameters = function () { return [
        { type: i0.Injector },
        { type: api.ConfirmationService }
    ]; };
    NgxCrudManageLayoutComponent.propDecorators = {
        actions: [{ type: i0.Input }],
        form: [{ type: i0.Input }],
        onAction: [{ type: i0.Output }]
    };

    exports.NgxCrudLayoutSetting_ManageConfig_Mode = void 0;
    (function (NgxCrudLayoutSetting_ManageConfig_Mode) {
        NgxCrudLayoutSetting_ManageConfig_Mode["modal"] = "modal";
        NgxCrudLayoutSetting_ManageConfig_Mode["custom"] = "custom";
    })(exports.NgxCrudLayoutSetting_ManageConfig_Mode || (exports.NgxCrudLayoutSetting_ManageConfig_Mode = {}));
    ;

    var NgxCrudGridComponent = /** @class */ (function (_super) {
        __extends(NgxCrudGridComponent, _super);
        function NgxCrudGridComponent(dialog, confirmDialog) {
            var _this = _super.call(this) || this;
            _this.dialog = dialog;
            _this.confirmDialog = confirmDialog;
            // loading indicator
            _this._loading = true;
            // breadcrumbs
            _this.breadcrumbs = [];
            // on grid ready
            _this.onReady = new i0.EventEmitter();
            // result
            _this._result = { results: [], total: 0 };
            return _this;
        }
        Object.defineProperty(NgxCrudGridComponent.prototype, "layout", {
            set: function (value) {
                if (value) {
                    this._layout = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        NgxCrudGridComponent.prototype.ngOnInit = function () {
            // init dialog key
            this._dialogKey = "crud_grid_layout_cd_" + NgxUtility.getUniqueString();
            // inti filter
            this.initFilter();
        };
        NgxCrudGridComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this.templates) {
                this.templates.forEach(function (item) {
                    switch (item.getType()) {
                        case 'custom':
                            {
                                _this._customColumnTemplate = item.template;
                            }
                            break;
                    }
                });
            }
        };
        // handle when user click on add button
        NgxCrudGridComponent.prototype.handleActionClick = function (action) {
            // check for type
            if (action.mode === exports.NgxCrudLayoutSetting_ManageConfig_Mode.modal) {
                this.openManageDialog({ layout: this._layout, model: null });
            }
            else {
                // fire action
                this._layout.setting.actionConfig.onAction(action);
            }
        };
        // get action dialog from the setting
        NgxCrudGridComponent.prototype.getModalActionAction = function () {
            var actionConfig = this._layout.setting.actionConfig;
            return actionConfig.actions.find(function (m) { return m.mode == exports.NgxCrudLayoutSetting_ManageConfig_Mode.modal; });
        };
        // open manage dialog
        NgxCrudGridComponent.prototype.openManageDialog = function (data) {
            var _this = this;
            // get action config
            var action = this.getModalActionAction();
            if (action) {
                var dialogRef = this.dialog.open(NgxCrudManageDialogComponent, {
                    header: action.modalConfig.title,
                    width: action.modalConfig.width,
                    contentStyle: NgxUtility.dialogContentStyle(),
                    data: data
                });
                var ref1_1 = dialogRef.onClose.subscribe(function (result) {
                    ref1_1.unsubscribe();
                    if (result) {
                        // search result
                        _this.lodResult();
                    }
                });
            }
            else {
                throw 'Invalid Modal Action';
            }
        };
        // when table filter changed
        NgxCrudGridComponent.prototype.handleFilterChanged = function (filter) {
            // set filter
            var reqFilter = ___namespace.cloneDeep(filter);
            // only set basic filter from grid
            this._layout.setting.gridConfig.action.filter.pageNo = reqFilter.pageNo;
            this._layout.setting.gridConfig.action.filter.perPage = reqFilter.perPage;
            this._layout.setting.gridConfig.action.filter.sortField = reqFilter.sortField;
            this._layout.setting.gridConfig.action.filter.sortOrder = reqFilter.sortOrder;
            // fire filter
            this._layout.setting.gridConfig.action.onFilterChanged(this._layout.setting.gridConfig.action.filter);
            // fire load result
            this.lodResult();
        };
        // handle search
        NgxCrudGridComponent.prototype.handleSearch = function (text) {
            // set filter
            this._layout.setting.gridConfig.action.filter.pageNo = 0;
            this._layout.setting.gridConfig.action.filter.searchText = text;
            // fire load result
            this.lodResult();
        };
        // for edit action
        NgxCrudGridComponent.prototype.onActionEdit = function (row) {
            var modalAction = this.getModalActionAction();
            if (modalAction) {
                this.openManageDialog({ model: row, layout: this._layout });
            }
            else {
                this.invokeGridAction('edit', row);
            }
        };
        // for delete action
        NgxCrudGridComponent.prototype.onActionDelete = function (row) {
            var _this = this;
            this.confirmDialog.confirm({
                header: 'Confirmation',
                message: 'Are you sure that you want to delete?',
                key: this._dialogKey,
                icon: 'pi pi-exclamation-triangle',
                accept: function () {
                    _this.invokeGridAction('delete', row);
                }
            });
        };
        // invoke grid action
        NgxCrudGridComponent.prototype.invokeGridAction = function (actionName, data) {
            if (this._layout.setting.gridConfig.action.customAction.invoke) {
                this._layout.setting.gridConfig.action.customAction.invoke(actionName, data);
            }
        };
        // init filter
        NgxCrudGridComponent.prototype.initFilter = function () {
            this._filter = {
                pageNo: 0,
                perPage: this._layout.setting.gridConfig.perPage,
                sortField: this._layout.setting.gridConfig.sortField,
                sortOrder: this._layout.setting.gridConfig.sortOrder,
                formFilter: null,
                searchText: null
            };
            // set filter
            this._layout.setting.gridConfig.action['filter'] = this._filter;
            // call on ready
            this.onReady.emit(this._layout);
            // load result
            this.lodResult();
        };
        // load results
        NgxCrudGridComponent.prototype.lodResult = function () {
            var _this = this;
            this._loading = true;
            this._layout.setting.gridConfig.action.loadResult(function (result) {
                // set result
                _this._result = result;
                // hide loading
                _this._loading = false;
            });
        };
        NgxCrudGridComponent.prototype.ngOnDestroy = function () {
            this.dispose();
        };
        return NgxCrudGridComponent;
    }(BaseComponent));
    NgxCrudGridComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-crud-grid',
                    template: "<!-- Header -->\n<ngx-header [header]=\"_layout?.setting?.pageTitle\" [breadcrumbs]=\"_layout?.setting?.gridConfig?.breadcrumbs\">\n    <div actionContent>\n        <!--manage action-->\n        <ng-container *ngFor=\"let action of _layout?.setting?.actionConfig?.actions\">\n            <button type=\"button\" pButton pRipple [class]=\"action?.styleClass\" (click)=\"handleActionClick(action)\"\n                [label]=\"action?.label\" [icon]=\"action?.icon\"></button>\n        </ng-container>\n        <!--action content-->\n        <ng-content select=\"[headerActionContent]\"></ng-content>\n    </div>\n    <!--Header Main Content-->\n    <ng-content select=\"[headerMainContent]\"></ng-content>\n</ngx-header>\n\n<!-- Content -->\n<div>\n    <!--For top content-->\n    <ng-content></ng-content>\n    <!--Main Content-->\n    <div class=\"row\">\n        <div class=\"col-12\">\n            <!-- Header -->\n            <div class=\"card shadow\">\n                <!--Search-->\n                <ng-container *ngIf=\"_layout?.setting?.gridConfig?.enableSearch\">\n                    <ngx-search (onSearch)=\"handleSearch($event)\">\n                        <ng-content select=\"[searchContent]\"></ng-content>\n                    </ngx-search>\n                </ng-container>\n\n                <!--Ngx Table-->\n                <ngx-primeng-basic-grid [key]=\"_layout?.setting?.gridConfig?.pk\" [columns]=\"_layout?.columns\"\n                    [result]=\"_result\" [filter]=\"_filter\" (onFilterChanged)=\"handleFilterChanged($event)\"\n                    [loading]=\"_loading\">\n\n                    <!--Custom column-->\n                    <ng-template gridTemplate=\"custom\" let-row=\"row\" let-column=\"column\">\n                        <!--Custom column-->\n                        <ng-container *ngTemplateOutlet=\"_customColumnTemplate;context:{row:row,column:column}\">\n                        </ng-container>\n\n                        <!--For action column-->\n                        <ng-container *ngIf=\"column.key=='action'\">\n                            <!--Edit-->\n                            <button pButton pRipple type=\"button\" icon=\"pi pi-pencil\"\n                                class=\"p-button-rounded p-button-text p-button-sm mr-2\" *ngIf=\"row?.action?.edit\"\n                                (click)=\"onActionEdit(row)\"></button>\n                            <!--Delete-->\n                            <button pButton pRipple type=\"button\" icon=\"pi pi-trash\"\n                                class=\"p-button-rounded p-button-text p-button-sm p-button-danger\"\n                                *ngIf=\"row?.action?.delete\" (click)=\"onActionDelete(row)\"></button>\n                        </ng-container>\n\n                    </ng-template>\n\n                </ngx-primeng-basic-grid>\n            </div>\n        </div>\n    </div>\n    <!--Footer content-->\n    <ng-content select=[footer]></ng-content>\n</div>\n\n<!--Confirm dialog-->\n<p-confirmDialog appendTo=\"body\" [key]=\"_dialogKey\"></p-confirmDialog>",
                    styles: [""]
                },] }
    ];
    NgxCrudGridComponent.ctorParameters = function () { return [
        { type: dynamicdialog.DialogService },
        { type: api.ConfirmationService }
    ]; };
    NgxCrudGridComponent.propDecorators = {
        templates: [{ type: i0.ContentChildren, args: [ngxPrimengGrid.GridCustomTemplate,] }],
        layout: [{ type: i0.Input }],
        breadcrumbs: [{ type: i0.Input }],
        onReady: [{ type: i0.Output }]
    };

    var NgxCrudLayoutModule = /** @class */ (function () {
        function NgxCrudLayoutModule() {
        }
        return NgxCrudLayoutModule;
    }());
    NgxCrudLayoutModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        NgxCrudManageComponent,
                        NgxCrudManageDialogComponent,
                        NgxCrudManageLayoutComponent,
                        NgxCrudGridComponent
                    ],
                    entryComponents: [NgxCrudManageDialogComponent],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        ngxPrimengGrid.NgxPrimengGridModule,
                        NgxWrapperSharedModule,
                        button.ButtonModule,
                        ngxPrimengForm.NgxPrimengFormModule,
                        dynamicdialog.DynamicDialogModule,
                        confirmdialog.ConfirmDialogModule
                    ],
                    providers: [
                        dynamicdialog.DialogService,
                        api.ConfirmationService
                    ],
                    exports: [NgxCrudGridComponent, NgxCrudManageLayoutComponent, NgxCrudManageComponent]
                },] }
    ];

    var NgxCrudService = /** @class */ (function () {
        function NgxCrudService() {
        }
        NgxCrudService.prototype.prepareLayout = function (rawLayout) {
            if (rawLayout) {
                var layout = {
                    api: this.prepareApiConfig(rawLayout),
                    columns: ___namespace.has(rawLayout, 'columns') ? rawLayout.columns : [],
                    form: this.prepareFormConfig(rawLayout),
                    setting: this.prepareSettingConfig(rawLayout)
                };
                return layout;
            }
            return null;
        };
        NgxCrudService.prototype.prepareFormRoute = function (activatedRoute, callback) {
            // set config
            var config = activatedRoute.snapshot.data['config'];
            if (config) {
                // set layout key
                config['layoutKey'] = ___namespace.has(config, 'layoutKey') ? config.layoutKey : 'layout';
                // get layout object
                var rawLayout = activatedRoute.snapshot.data[config.layoutKey];
                if (rawLayout) {
                    // prepare layout
                    var layout = this.prepareLayout(rawLayout);
                    // call back
                    callback(config, layout);
                }
            }
        };
        // prepare api
        NgxCrudService.prototype.prepareApiConfig = function (data) {
            if (___namespace.has(data, 'api')) {
                var api = data.api;
                var apiConfig = {
                    changeStatus: ___namespace.has(api, 'changeStatus') ? api.changeStatus : null,
                    delete: ___namespace.has(api, 'delete') ? api.delete : null,
                    manage: ___namespace.has(api, 'manage') ? api.manage : null,
                    search: ___namespace.has(api, 'search') ? api.search : null,
                    command: function (path) { return path; }
                };
                return apiConfig;
            }
            return null;
        };
        // prepare setting
        NgxCrudService.prototype.prepareSettingConfig = function (data) {
            // setting layout
            var settingLayout = {};
            // check setting attribute is exist or not
            if (___namespace.has(data, 'setting')) {
                // setting instance
                var setting = data.setting;
                // title
                settingLayout.pageTitle = ___namespace.has(setting, 'pageTitle') ? setting.pageTitle : 'NA';
                // prepare manage Config
                this.prepareManageConfigSetting(setting, settingLayout);
                // prepare grid config
                this.prepareGridConfigSetting(setting, settingLayout);
            }
            return settingLayout;
        };
        NgxCrudService.prototype.prepareManageConfigSetting = function (setting, settingLayout) {
            if (___namespace.has(setting, 'actionConfig')) {
                // action config
                var actionConfig = setting.actionConfig;
                // init config
                settingLayout.actionConfig = { actions: [], enable: false };
                // check manage is enabled or not
                settingLayout.actionConfig.enable = ___namespace.has(actionConfig, 'enable') ? actionConfig.enable : false;
                if (settingLayout.actionConfig.enable) {
                    // get actions
                    var actions = ___namespace.has(actionConfig, 'actions') ? actionConfig.actions : [];
                    // action Null check
                    if (actions && actions.length > 0) {
                        // loop action info
                        actions.forEach(function (info) {
                            // action instance
                            var actionInfo = {};
                            // set key
                            actionInfo.key = ___namespace.has(info, 'key') ? info.key : null;
                            // set label
                            actionInfo.label = ___namespace.has(info, 'label') ? info.label : null;
                            // set icon
                            actionInfo.icon = ___namespace.has(info, 'icon') ? info.icon : null;
                            // set styleClass
                            actionInfo.styleClass = ___namespace.has(info, 'styleClass') ? info.styleClass : 'p-button-sm p-button-outlined';
                            // set mode
                            actionInfo.mode = ___namespace.has(info, 'mode') ? info.mode : null;
                            // check for modal config
                            if (___namespace.has(info, 'modalConfig')) {
                                actionInfo.modalConfig = {
                                    title: ___namespace.has(info, 'modalConfig.title') ? info.modalConfig.title : null,
                                    width: ___namespace.has(info, 'modalConfig.width') ? info.modalConfig.width : 'auto'
                                };
                            }
                            // push
                            settingLayout.actionConfig.actions.push(actionInfo);
                        });
                    }
                }
                // for action
                settingLayout.actionConfig.onAction = function (action) {
                    // sudo action
                };
            }
        };
        NgxCrudService.prototype.prepareGridConfigSetting = function (setting, settingLayout) {
            if (___namespace.has(setting, 'gridConfig')) {
                // grid config instance
                var gridConfig = setting.gridConfig;
                // init config
                settingLayout.gridConfig = {};
                // set pk
                settingLayout.gridConfig.pk = ___namespace.has(gridConfig, 'pk') ? gridConfig.pk : null;
                // set layoutId
                settingLayout.gridConfig.layoutId = ___namespace.has(gridConfig, 'layoutId') ? gridConfig.layoutId : null;
                // set enableSearch
                settingLayout.gridConfig.enableSearch = ___namespace.has(gridConfig, 'enableSearch') ? gridConfig.enableSearch : false;
                // set sortField
                settingLayout.gridConfig.sortField = ___namespace.has(gridConfig, 'sortField') ? gridConfig.sortField : null;
                // set sortOrder
                settingLayout.gridConfig.sortOrder = ___namespace.has(gridConfig, 'sortOrder') ? gridConfig.sortOrder : -1;
                // set sortOrder
                settingLayout.gridConfig.perPage = ___namespace.has(gridConfig, 'perPage') ? gridConfig.perPage : 10;
                // set breadcrumbs
                settingLayout.gridConfig.breadcrumbs = ___namespace.has(gridConfig, 'breadcrumbs') ? gridConfig.breadcrumbs : [];
                // action
                // sudo action
                settingLayout.gridConfig.action = {
                    customAction: {},
                    onFilterChanged: function (filter) { },
                    loadResult: function () { }
                };
            }
        };
        NgxCrudService.prototype.prepareFormConfig = function (data) {
            // init form form config
            var formConfig = {};
            // check form attribute is exist or not
            if (___namespace.has(data, 'form')) {
                // form instance
                var form = data.form;
                // check control
                if (___namespace.has(form, 'controls')) {
                    // set controls
                    formConfig.controls = form.controls;
                    // prepare action
                    // sudo function
                    formConfig.action = {
                        onExecute: function (formValue, action, data, callback) { },
                        onPrepareValue: function (formgroup, formItems, data) { },
                        onPatchValue: function (formgroup, formItems, data) { }
                    };
                }
            }
            return formConfig;
        };
        return NgxCrudService;
    }());
    NgxCrudService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgxCrudService_Factory() { return new NgxCrudService(); }, token: NgxCrudService, providedIn: "root" });
    NgxCrudService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxCrudService.ctorParameters = function () { return []; };

    /*
     * Public API Surface of ngx-wrapper
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BaseComponent = BaseComponent;
    exports.DialogBaseComponent = DialogBaseComponent;
    exports.DialogFormBaseComponent = DialogFormBaseComponent;
    exports.DynamicFormBaseComponent = DynamicFormBaseComponent;
    exports.FormBaseComponent = FormBaseComponent;
    exports.NgxCardLayoutComponent = NgxCardLayoutComponent;
    exports.NgxCrudLayoutModule = NgxCrudLayoutModule;
    exports.NgxCrudService = NgxCrudService;
    exports.NgxHeaderComponent = NgxHeaderComponent;
    exports.NgxInlineLoaderComponent = NgxInlineLoaderComponent;
    exports.NgxLambdaUtility = NgxLambdaUtility;
    exports.NgxListDataViewComponent = NgxListDataViewComponent;
    exports.NgxManageActionLayoutComponent = NgxManageActionLayoutComponent;
    exports.NgxManageLayoutBaseComponent = NgxManageLayoutBaseComponent;
    exports.NgxManageLayoutComponent = NgxManageLayoutComponent;
    exports.NgxManageLayoutDialogBaseComponent = NgxManageLayoutDialogBaseComponent;
    exports.NgxManageLayoutModule = NgxManageLayoutModule;
    exports.NgxManageLayoutService = NgxManageLayoutService;
    exports.NgxSearchComponent = NgxSearchComponent;
    exports.NgxUtility = NgxUtility;
    exports.NgxValidationService = NgxValidationService;
    exports.NgxWrapperModule = NgxWrapperModule;
    exports.NgxWrapperSharedModule = NgxWrapperSharedModule;
    exports.ɵa = NgxFullpageLoaderComponent;
    exports.ɵb = NgxCrudManageComponent;
    exports.ɵc = NgxCrudManageDialogComponent;
    exports.ɵd = NgxCrudManageLayoutComponent;
    exports.ɵe = NgxCrudGridComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-wrapper.umd.js.map
