import { Injector } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Observable } from 'rxjs';
import { NgxPrimengFormService, INgxPrimengForm, INgxPrimengFormResult } from 'ngx-primeng-form';
import { FormBaseComponent } from './form.base';
export declare abstract class DynamicFormBaseComponent<TModel> extends FormBaseComponent<TModel> {
    protected ngxPrimengFormService: NgxPrimengFormService;
    constructor(dynamicFormInjector: Injector);
    protected prepareForm(formBuilder: FormBuilder, jsonForms: INgxPrimengForm[]): INgxPrimengFormResult;
    protected loadRemoteJsonForm(formBuilder: FormBuilder, formObservable: Observable<INgxPrimengForm[]>): Observable<INgxPrimengFormResult>;
}
