import { SelectItem } from 'primeng/api';
import { INgxResult } from '../_interfaces/iresult';
import { FormGroup } from '@angular/forms';
import { ActivatedRoute } from '@angular/router';
export declare class NgxUtility {
    static clone<T>(obj: T): T;
    static hasProperty(obj: Object, property: string): boolean;
    static hasPropertyValue(obj: Object, property: string): any;
    static toSelectItems<T>(items: T[], valueFeild: string, labelFeild: string): SelectItem[];
    static toSelectItemsFormat<T>(items: T[], valueFeild: string, labelFeilds: string[], startSeprator?: string, endSeperator?: string): SelectItem[];
    static scrollToTop(): void;
    static scrollTo(elementId: string): void;
    static toFloat(value: any, defValue?: number): number;
    static toFloatExact(value: number): number;
    static toInt(value: any, defValue?: number): number;
    static trim(obj: any): void;
    static getUniqueString(): string;
    static jsonToDate(jsonStr: any): Date;
    static isValidDate(date: Date): boolean;
    static localToUtc(date: Date): Date;
    static utcToLocal(date: Date): Date;
    static toDateFormat(dtStr: string, format: string, timeZone?: any): string;
    static toAmountFormat(amount: any, currency?: string): string;
    static focusElement(elementId: string): void;
    static dialogContentStyle(maxHeight?: string): any;
    static datePickerToDate(value: string, splitChar?: string): Date;
    static monthPickerToDate(value: string, splitChar?: string): Date;
    static isSuccessResult(result: INgxResult): boolean;
    static patchFormValue(value: Object, formGroup: FormGroup): void;
    static cleanNullableObject(obj: any): void;
    static getRouteKey(key: string, activatedRoute: ActivatedRoute): string;
    static getRouteData(key: string, activatedRoute: ActivatedRoute): any;
}
