import { INgxResult } from "../../core/_interfaces/iresult";
import { INgxCrudLayout } from "./_crud-layout";
export interface INgxCrudAction {
    key: string;
    name: string;
    styleClass: string;
    validate: boolean;
    serviceCall: boolean;
    resetControls?: string[];
    confirmMessage?: string;
}
export interface INgxCrudActionCallback {
    action: INgxCrudAction;
    result?: INgxResult;
}
export interface INgxCrudLayoutDialogData<T> {
    data?: any;
    layout?: INgxCrudLayout;
    model: T;
}
