import { OnInit, EventEmitter } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { INgxManageLayoutActionButton, INgxManageLayoutConfirmation } from '../../models/ngx-manage-layout.model';
import { NgxValidationService } from '../../../services/ngx-validation.service';
import { ConfirmationService } from 'primeng/api';
export declare class NgxManageActionLayoutComponent implements OnInit {
    private validationService;
    private confirmDialog;
    actions: INgxManageLayoutActionButton[];
    confirmations: INgxManageLayoutConfirmation[];
    form: FormGroup;
    onAction: EventEmitter<INgxManageLayoutActionButton>;
    dialogKey: string;
    constructor(validationService: NgxValidationService, confirmDialog: ConfirmationService);
    ngOnInit(): void;
    handleAction(item: INgxManageLayoutActionButton): void;
    private checkConfirmation;
}
