import { OnInit, EventEmitter, TemplateRef, QueryList, AfterContentInit } from '@angular/core';
import { Router } from '@angular/router';
import { INgxGridResult, INgxGridFilter, INgxGridInstance, GridCustomTemplate } from 'ngx-primeng-grid';
import { BaseComponent } from '../../../core/_base/base';
import { INgxManageLayout, INgxManageLayoutAction } from '../../models/ngx-manage-layout.model';
import { IBreadcrumb } from '../../../ngx-wrapper-shared/models/breadcrumb';
export declare class NgxManageLayoutComponent extends BaseComponent implements OnInit, AfterContentInit {
    private router;
    templates: QueryList<GridCustomTemplate>;
    _layout: INgxManageLayout;
    result: INgxGridResult<any>;
    filter: INgxGridFilter;
    loading: boolean;
    set layout(value: INgxManageLayout);
    onAction: EventEmitter<INgxManageLayoutAction<any>>;
    onFilter: EventEmitter<INgxGridFilter>;
    onSearch: EventEmitter<string>;
    breadcrumbs: IBreadcrumb[];
    onRowSelected: EventEmitter<any>;
    customColumnTemplate: TemplateRef<any>;
    constructor(router: Router);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    handleAdd(): void;
    handleAction($instance: INgxGridInstance<any>): void;
    handleFilterChanged($filter: INgxGridFilter): void;
    handleSearch(text: string): void;
    handleOnRowSelected($event: any): void;
}
