import { Injector } from '@angular/core';
import { DynamicFormBaseComponent } from './dynamic-form.base';
export declare abstract class DialogFormBaseComponent<TDialogModel, TModelModel> extends DynamicFormBaseComponent<TModelModel> {
    private dialogBaseRef;
    private dialogBaseConfig;
    constructor(dialogFormInjector: Injector);
    get dialogData(): TDialogModel;
    closeDialog(result?: any): void;
}
