import { EventEmitter, Injector, OnInit } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { ConfirmationService } from 'primeng/api';
import { FormBaseComponent } from '../../../core/_base/form.base';
import { INgxCrudAction } from '../../_models/_crud-manage';
export declare class NgxCrudManageLayoutComponent extends FormBaseComponent<any> implements OnInit {
    private confirmDialog;
    actions: INgxCrudAction[];
    form: FormGroup;
    onAction: EventEmitter<INgxCrudAction>;
    _dialogKey: string;
    constructor(injector: Injector, confirmDialog: ConfirmationService);
    ngOnInit(): void;
    private prepareDefaultActions;
    handleAction(item: INgxCrudAction): void;
    private checkConfirmation;
}
