import { EventEmitter, Injector, OnDestroy, OnInit } from '@angular/core';
import { INgxCrudLayout } from '../../_models/_crud-layout';
import { DynamicFormBaseComponent } from '../../../core/_base/dynamic-form.base';
import { FormBuilder } from '@angular/forms';
import { INgxPrimengForm } from 'ngx-primeng-form';
import { INgxCrudAction, INgxCrudActionCallback } from '../../_models/_crud-manage';
export declare class NgxCrudManageComponent extends DynamicFormBaseComponent<any> implements OnInit, OnDestroy {
    private formBuilder;
    _formItems: INgxPrimengForm[];
    layout: INgxCrudLayout;
    onAction: EventEmitter<INgxCrudActionCallback>;
    data: any;
    constructor(injector: Injector, formBuilder: FormBuilder);
    ngOnInit(): void;
    private loadForm;
    handleOnAction(action: INgxCrudAction): void;
    ngOnDestroy(): void;
}
