import { Injector } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { INgxPrimengForm } from 'ngx-primeng-form';
import { INgxManageLayoutDialogData, INgxManageLayoutActionButton } from '../models/ngx-manage-layout.model';
import { DialogFormBaseComponent } from '../../core/_base/dialog-form.base';
export declare abstract class NgxManageLayoutDialogBaseComponent<TModel> extends DialogFormBaseComponent<INgxManageLayoutDialogData<TModel>, TModel> {
    formItems: INgxPrimengForm[];
    protected abstract handleOnAction(formValue: any, action: INgxManageLayoutActionButton): void;
    constructor(manageDialognjector: Injector);
    protected loadForm(formBuilder: FormBuilder): void;
    private processData;
    handleAction(event: INgxManageLayoutActionButton): void;
    private getActionFormValue;
    protected overrideSetFormDataPreAction(model: TModel): TModel;
    protected overrideSetFormDataPostAction(): void;
}
